//
//  RemoteViewController.m
//  AUDataLoadersExample
//
//  Created by Emil Wojtaszek on 21.07.2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

//Controllers
#import "RemoteViewController.h"

//Models
#import "Report.h"

@interface RemoteViewController ()

@end

@implementation RemoteViewController

////////////////////////////////////////////////////////////////////////////////////////////////////
- (id)initWithStyle:(UITableViewStyle)style {
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
        self.showRefreshControl = YES;
    }
    return self;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
- (void)viewDidLoad {
    [super viewDidLoad];
    self.title = @"Remote";
}

////////////////////////////////////////////////////////////////////////////////////////////////////
- (void)viewDidUnload {
    [super viewDidUnload];
}

////////////////////////////////////////////////////////////////////////////////////////////////////
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
- (void)createDataLoaders {
    // add local data laoder
    AULocalDataLoader* local = [[AULocalDataLoader alloc] initWithDelegate:self];
    [local setFetchRequest:[Report fetchRequest]];
    [local setSortDescriptor:[NSSortDescriptor sortDescriptorWithKey:@"title" ascending:YES]];
    [self addBasicLocalDataLoader:local];
    
    AURemoteDataLoader* remote = [[AURemoteDataLoader alloc] initWithDelegate:self];
    [remote setResourcePath:[NSString stringWithFormat: @"/reports?auth_token=%@", @"TjqKziqq5WvgdTJ2BqSf"]];
    [self addBasicRemoteDataLoader:remote];
}

////////////////////////////////////////////////////////////////////////////////////////////////////
- (void)tableViewDidReachEnd {
    // default do nothing, use for e.g. load more data
}


#pragma mark - AUDataLoader Delegate

////////////////////////////////////////////////////////////////////////////////////////////////////
- (void)dataLoaderDidStartLoadingData:(AUDataLoader *)dataSource {
	[super dataLoaderDidStartLoadingData:dataSource];
}

////////////////////////////////////////////////////////////////////////////////////////////////////
- (void)dataLoaderDidLoadData:(AUDataLoader *)dataSource {
	[super dataLoaderDidLoadData:dataSource];
}

////////////////////////////////////////////////////////////////////////////////////////////////////
- (void)dataLoaderDidFailLoadData:(AUDataLoader *)dataSource withError:(NSError *)error {
	[super dataLoaderDidFailLoadData:dataSource withError:error];
}


#pragma mark - UITableView DataSource

////////////////////////////////////////////////////////////////////////////////////////////////////
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *CellIdentifier  = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier: CellIdentifier];
    
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
    Report* report = [[self basicLocalDataLoader] objectAtIndexPath:indexPath];
    cell.textLabel.text = [report.guid stringValue];
    
    return cell;
}


#pragma mark - UITableView Delegate

////////////////////////////////////////////////////////////////////////////////////////////////////
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
}

@end
